{
                       
                              Typing Tutorial        
                         By Motaz Abdel Azim Altahir 
                                version 1.2          
                           15/3/1996  -  10/1996     
                       
}

PROGRAM TYPING(I,O);
Uses Crt,Dos,Printer,Motaz,Mcrt;

CONST                      {  variables  }
  bk='';
  DFN:array [1..2] of namestr=('ADF','EDF');
  mbar:array [1..5,0..2,1..2] of string[22]=
  ((('','Practice'),(' ','New lesson'),('','Test')),
  (('','Configure'),('','Rename'),('','Colors')),
  (('','Report'),('','Screen'),(' ','Print report')),
  (('','Help'),('','Help'),(' ','About')),
  (('','File'),(' ','Delete a student'),('','Quit')));

    Let:Array [1..2] of String[66]=(' .1/2-3\4:5|67(8)9$0=!+><_#^%*"&@',
    ' ERTMINO,.UCGHYPWBVQXZ`1/2-3'+#39+'4:5\6?7(8)9$0=!+><_#^[]{}%*"&@|~');

TYPE    (**** Students data record type ****)
  DR=record
  nam:string[30];  (** Student name          **)
  dat:string[10];  (** Date begin            **)
  ldat:string[10]; (** Last practice date    **)
  speed:0..200;    (** Speed                 **)
  acur:0..100;     (** Acuracy               **)
  tim:integer;     (** Whale practice time   **)
  last:0..100;     (** Number of last letter **)
end;

VAR                (**** Variables ****)
 Err:Byte;
 i,j,k,l,m,n,g,f,men,fg,bg,sys,acur,sped,tm:integer;
 ll,stu,col,sq,dfc,les,spe,sum,ac,ptime,acsum:integer;
 c:char;
 na,strg,str1,str2,str3,str4:string;
 dir,cdir:string[60];
 Fname:namestr;
 dd,mm,yy,dw,h0,h1,n0,n1,s0,s1,ss,hh0,nn0,ss0,hh1,nn1,ss1:word;
 ex,Soun:boolean;
 dat:array [1..65] of string[40];
 RA:array [1..16] of DR;
 DF:text;
 rg:registers;
 moux,mouy,bot:word;
 scr:array [0..4000] of byte;
 RF,fl:text;


FUNCTION WPM(hh0,nn0,ss0,hh1,nn1,ss1:word;len:integer):integer;
var                       {  speed (WPM)  }
  sum,sum0,sum1:real;
  wl:real;
begin
 wl:=6;
  if (hh1=0) and (hh0>0) then hh1:=24;
    sum0:=hh0*60+nn0+ss0/60;
    sum1:=hh1*60+nn1+ss1/60;
    sum:=sum1-sum0;
 if sum<>0 then WPM:=round((len/wl)/sum);
end;

Procedure CapsOff;   {  Caps off  }
begin
  mem[0:$417]:=0;
end;

PROCEDURE BEEP(a:integer);  {  BEEP  }
begin
  if Soun then
  for i:=1 to 2 do
   begin
    sound(i*200+a);
     delay(50);
   end;
  nosound;
end;

PROCEDURE LOAD;            {  LOAD  }
begin
 for i:=0 to 2000 do
  begin
  mem[XGA:i*2]:=scr[i*2];
  mem[XGA:i*2+1]:=scr[i*2+1];
  end;
end;

PROCEDURE SAVE;            {  SAVE  }
begin
 for i:=0 to 2000 do
  begin
  scr[i*2]:=mem[XGA:i*2];
  scr[i*2+1]:=mem[XGA:i*2+1];
 end;
end;

PROCEDURE FILE_IO(o,b:integer); {  OPEN RECORD FILE  }
Begin
    chdir(cdir);
    if o=0 then
     begin
        strg:=fsearch(DFN[sys]+'.typ',getenv(''));
        if strg='' then
        begin
         assign(RF,DFN[sys]+'.typ');
          {$i-}
          rewrite(RF);
          Err:=IOresult;
          if Err<>0 then begin Error('',Err); exit; end;
          close(RF);
         end;
       assign(RF,DFN[sys]+'.typ'); {  read  }
       reset(RF);
       Err:=IOresult;
          if Err<>0 then begin Error('',Err); exit; end;
        LL:=0;
        while not eof(RF) do
        begin
       inc(LL);
      with RA[ll] do
      begin
       Err:=ioresult;
       if Err<>0 then begin Error('',Err); exit; end;
       readln(RF,nam);
       readln(RF,dat);
       readln(RF,ldat);
       readln(RF,speed);
       readln(RF,acur);
       readln(RF,tim);
       readln(RF,last);
      end;
     end;
     {$i+}
    close(RF);
   end
  else
  begin
   if b=1 then str2:='.TYP' else str2:='.BAK';
   assign(RF,DFN[sys]+str2); {  write  }
    color(fg,bg);
    wind(20,11,60,13,2,'');
    clrscr;
    write(spc(8),'Wait ... Saving ',DFN[sys],str2);
    {$i-}
    rewrite(RF);
       RA[stu].ldat:=motaz.strg(dd)+'-'+motaz.strg(mm)+'-'+motaz.strg(yy);
    for i:=1 to ll do
      with RA[i] do
      begin
       getdate(yy,mm,dd,dw);
       Err:=IOResult;
       if Err<>0 then begin Error('',Err); exit; end;
       writeln(RF,nam);
       writeln(RF,dat);
       writeln(RF,ldat);
       writeln(RF,speed);
       writeln(RF,acur);
       writeln(RF,tim);
       writeln(RF,last);
      end;
  close(RF);
  {$i+}
  delay(500);
  end;
end;

PROCEDURE CLEAR;  {  CLEAR SCREEN  }
begin
  str4:=''; if stu>0 then str4:=' '+RA[stu].nam+' ';
   color(14,0); if fg=11 then color(15,0);
   wind(1,1,80,25,2,str4);
    window(2,3,79,24);
     textcolor(bg);
      textbackground(0);
        for i:=1 to 22 do begin
         for j:=0 to 7 do begin
         gotoxy(j*9+1,i);
         write(' ۲ ');
         end;  write('  ');end;
         for i:=1 to 8 do
          write(' ۲ ');
          write(' ');
         textbackground(0);
         textcolor(8);
        gotoxy(3,1);
       for i:=1 to 76 do
      write('');
     gotoxy(2,1);
    for i:=1 to 8 do
   write('۲  ');
   write(' ');
  if stu<>0 then
  begin
     window(1,1,80,25);
     gotoxy(79,2);write('');
      textbackground(0);
       gotoxy(2,2);write(' ');
        textbackground(bg);
         gotoxy(3,2);
         for i:=1 to 77 do
         write(' ');
        for i:=1 to 5 do
       begin
      textcolor(fg);
     gotoxy(i*12-5,2);
    write(Mbar[i,0,sys]);
   end;
  end;
 save;
end;

PROCEDURE MENU(X,Y:INTEGER;ST,la:STRING); {  MENU  }
 var
  max,no,ro:integer;
   str:array [1..21] of string[30];
    begin
    curs(0);
     if st[length(st)]='+' then st:=copy(st,1,length(st)-1);
     max:=0; no:=1; ro:=1; men:=0; rg.bx:=0;
      for i:=1 to 21 do
       str[i]:='';
        for i:=1 to length(st) do
         begin
          if st[i]='+' then begin inc(i); if str[no]<>'' then inc(no);
           if no>1 then if length(str[no-1])>max then max:=length(str[no-1]);
            end;
             if i<>length(st)+1 then
              str[no]:=str[no]+st[i];
               end;
              if length(str[no])>max then max:=length(str[no]);
   for i:=1 to max+4 do str[21]:=str[21]+' ';
     color(fg,bg);
     wind(x,y,x+max+5,y+no+1,1,la);
      repeat
     window(x+1,y+1,x+max+4,y+no);
       textbackground(bg);clrscr;
     window(x+1,y+1,x+max+4,y+no+1);
         for i:=1 to no do begin gotoxy(2,i);write(str[i]);end;
          textbackground(sq);
           gotoxy(1,ro);write(str[21]);
            gotoxy(2,ro);write(str[ro]);
           c:=' ';
           repeat
            intr($33,rg);
            bot:=rg.bx;
            if keypressed then c:=readkey;
             if bot>0 then c:=chr(13);
             if rg.cx div 30>moux div 30 then if sys=1 then c:=chr(75)
             else c:=chr(77)
              else if rg.cx div 30<moux div 30 then if sys=1 then c:=chr(77)
               else c:=chr(75);
                if rg.dx>mouy then c:=chr(80)
                  else if rg.dx<mouy then c:=chr(72);
            case ord(c) of
              72:inc(ro,-1);
              80:inc(ro);
              13:men:=ro;
              77:inc(col);
              75:inc(col,-1);
            end;
               if rg.dx<>mouy then mouy:=rg.dx;
               if rg.cx<>moux then moux:=rg.cx;
           until (c<>' ');
         if ro<1 then ro:=no else if ro>no then ro:=1;
  until (ord(c)=13) or (ord(c)=27)or (ord(c)=75) or (ord(c)=77);
  Curs(2);
end;

PROCEDURE EXT;              {  EXIT  }
begin
 clear;
 if (((les<>RA[stu].last) and(stu>0)) or ((sped<>RA[stu].speed) and (stu>0))
 or (ptime<>RA[stu].tim)) and (stu>0) then
  begin
  if RA[stu].speed=0 then RA[stu].speed:=sped;
  RA[stu].last:=les;
   RA[stu].speed:=sped;
    RA[stu].acur:=acur;
    RA[stu].tim:=ptime;
    if sys=1 then strg:='   +  '
     else strg:='save change and exit+exit without save';
      repeat
       menu(30,9,strg,'');
       until (men=1) or (men=2);
      if men=1 then begin
      file_io(1,1);
      clear;
    if sys=1 then begin strg:='   '; str1:='        +       '; end
     else begin strg:=' Backup '; str1:='     Yes    +     No'; end;
      repeat
      menu(30,9,str1,strg);
      until (men<>0) or (c=#27);
      if men=1 then file_io(1,2);
      end; end;
     window(1,1,80,25);
    textcolor(15);
   textbackground(0);
  clrscr;
 color(fg,bg);
 wind(14,10,65,12,2,''); clrscr;
 midle(1,'Thanks for using this program ...... Motaz');
 window(1,1,80,25);
 color(7,0);
 gotoxy(1,15);
 halt;
end;

PROCEDURE THEEND;       {  THE END  }
begin
  for i:=1 to 25 do
   begin
   color(fg,bg);
   wind(40-i,9,40+i,19,1,'');
   delay(50);
   clrscr; end;
   if sys=1 then begin
   writeln;
    writeln(spc(20),'');
     writeln;
     writeln(spc(5),'    ',RA[stu].nam);
    writeln;
    writeln(spc(5),'  --');
   end
   else begin
   writeln;
    writeln(spc(20),'The End');
     writeln;
    writeln(spc(2),'Good bay ',RA[stu].nam,' and see you later..');
    writeln;
    writeln(spc(8),'Motaz Abdel Azim Altahir-Khartoum');
   end;
  delay(1000);
   for i:=1 to 2 do
   play('$8-ehh5hjih4ij3i4hi4jlm-3mlj4jhih4ij4i4hf4feh-');
 for i:=1 to 2 do c:=readkey;
end;

PROCEDURE RENAME;       {  RENAME  }
begin
  repeat
   if sys=1 then str1:='    '
     else str1:='  Enter your name';
      color(fg,bg);
      wind(25,9,55,14,2,'');
       clrscr;
        writeln(str1); str1:='';
         write('  ');
          strg:=RemSpc(readstr('',30),2);
           k:=0;
           if strg='' then begin clear; exit; end
           else begin
          for i:=1 to ll do
         if strg=RA[i].nam then k:=1;
        if k=1 then if sys=1 then str1:=strg+'  '
       else str1:=strg+' already axists';
      beep(300);
     writeln(str1);
    end;
   until k=0;
  RA[stu].nam:=strg;
 clear;
 if stu=0 then stu:=ll+1;
end;

PROCEDURE STUD_NAME;   {  STUDENT NAME  }
var
 na:string;
 begin
  delay(200);
   na:='';
    if ll<16 then
     if sys=1 then na:='[   ]'
      else na:='[ NEW STUDENT ]';
       for i:=1 to ll do
        na:=na+'+'+RA[i].nam;
         repeat
        menu(30,11-ll div 2,na,'');
       until (men<>0) or (ord(c)=27);
      if c=#27 then begin ext; exit; end;
     if ll<16 then stu:=men-1 else stu:=men;
    if (ll<16) and (men=1) then
     begin
      rename;
       if strg='' then exit;
        inc(ll);
         str(dd,str1);
          str(mm,str2);
          str(yy,str3);
         RA[ll].nam:=strg;
         RA[ll].dat:=str1+'-'+str2+'-'+str3;
         RA[ll].speed:=0;
         RA[ll].acur:=100;
         RA[ll].tim:=0;
         RA[ll].last:=0;
        file_io(1,1);
    end;
end;

PROCEDURE SYST;          {  SYSTEM  }
begin
if pos(paramstr(1),'aA')>0 then men:=1
 else
  if pos(paramstr(1),'eE')>0 then men:=2
   else begin
   repeat
   menu(31,10,'   Arabic    +   English',' System '); {  System  }
    until (men<>0) or (ord(c)=27);
     if c=#27 then ext;
      end;
      stu:=0;
       sys:=men;
       if sys=1 then begin
        color(fg,bg);
        wind(28,10,54,14,2,'');
        clrscr;
        writeln('        Alt + Pause');
       write('    ');
      c:=readkey;
     end;
    file_io(0,1);
   while stu=0 do
  stud_name;
 if c=#27 then begin ext; exit; end;
end;

PROCEDURE MENU_BAR;    {  MENU BAR  }
Begin
  strg:='      '; col:=1;
   repeat
    load;
     window(1,1,80,25);
      str1:='';
       str1:=str1+Mbar[col,1,sys]+'+'+Mbar[col,2,sys];
        if Mbar[col,2,sys]='' then str1:=Mbar[col,1,sys];
         if col=1 then if sys=1 then str1:=str1+'+ +'
         else str1:=str1+'+Keyboard+Text';
         if col=2 then if sys=1 then
          begin
           if Soun then
             str1:=str1+'+ ' else str1:=str1+'+'
          end
         else if Soun then str1:=str1+'+Sound disable'
          else str1:=str1+'+Sound enable';
         textbackground(sq);
         gotoxy(col*12-5,2);
        write(Mbar[col,0,sys]);
       menu(col*12-5,3,str1,'');
     if col<1 then col:=5 else if col>5 then col:=1;
    until men<>0;
end;

Procedure About_Prog;  {  About program  }
begin
 if sys=1 then Strg:='   '
  else Strg:=' About program ';
 wind(10,8,70,22,2,Strg);
 cls;
 writeln;
 if sys=1 then
 begin
  writeln('               :   ');
  writeln('       : Turbo Pascal version 7.0');
  writeln('           : 1272 ');
  writeln('    ()   : 35,555 ');
  writeln('            : 60 ');
  writeln('     :');
  writeln('         Mitac (IBM compatible) 486, sx 25 MHz');
  midle(10,'  ');
  midle(11,'   ');
  midle(12,'  ');
 end
  else
 begin
  writeln('  Program name  : Typing Tutorial');
  writeln('  Language used : Turbo Pascal Version 7.0');
  writeln('  Number of Main program lines (source) : 1272 lines');
  writeln('  Size of Main program (source)         : 35,555 bytes');
  writeln('  Programming time  : 60 days');
  writeln('  The project is done in computer :');
  writeln('         Mitac (IBM compatible) 486, sx 25 MHz');
  midle(10,'Motaz Abdel Azim Altahir');
  midle(11,'Sudan University of science and technology');
  midle(12,'2 BSI');
 end;
 readkey;
end;

PROCEDURE ABOUT;      {  ABOUT  }
 begin
  Curs(0);
  for i:=1 to 20 do
   begin
    color(fg,bg);
    if stu>0 then strg:=' '+Mbar[4,2,sys]+' ' else strg:='';
    wind(40-i,11,40+i,19,2,Strg);
     delay(10);
      cls;
      end;
       beep(200);
          Midle(2,'  ');
          Midle(3,'Typing Tutorial');
          Midle(4,na);
          Midle(5,'Version 1.2');
          Midle(6,'(C) Copyright Oct. 1996, KHARTOUM');
   i:=0; c:='1';
  if stu=0 then
  repeat
   inc(i);
    if keypressed then c:=readkey;
   delay(50);
  until (i>150) or (c<>'1')
  else
  if stu>0 then
  begin
   readkey;
   About_Prog;
  end;
  Curs(2);
end;

PROCEDURE Init(O:INTEGER); {  SAVE COLOR  }
 var f:text;
     s:byte;
 begin
   chdir(cdir);
   fname:=fsearch('typ.ini',getenv(''));
    if fname='' then
     begin
      o:=1;
      cls;
      color(14,1);
      hcolor(15,2);
      short:=12;
       i:=Mssg('       Welcome in~Typing Tutorial program~       Version 1.2','',11);
     end;
     if o=1 then
      begin
         assign(f,'typ.ini');
          {$i-}
          rewrite(f);
          {$i+}
          Err:=IOresult;
          if Err<>0 then
           begin
             Error('',Err);
             exit;
           end;
          if Soun then s:=1 else s:=0;
          writeln(f,fg);
          writeln(f,bg);
          writeln(f,sq);
          writeln(f,s);
         close(f);
       end
       else
        begin
        assign(f,'typ.ini');
      {$i-}
      reset(f);
      readln(f,fg);
      readln(f,bg);
      readln(f,sq);
      readln(f,s);
      if s=1 then Soun:=True else Soun:=False;
      close(f);
     Err:=IOResult;
    if Err<>0 then Error('',Err);
 end;
  {$i+}
end;

PROCEDURE COLORS;        {  COLOR  }
 begin
  clear;
   if sys=1 then strg:='/+/+ /+ /+/+ /+/+ /'
    else strg:='Yellow/Blue+Black/Grey+White/Green+Cyan/Black+Yellow/Red+White/Brown+Yellow/Light Blue+Whit/Magenta';
     repeat
    menu(30,6,strg,'');
     until (men<>0) or (c=#27);
     if c=#27 then begin clear; exit; end;
   case men of
    1:begin fg:=14; bg:=9; sq:=12; end;
    2:begin fg:= 0; bg:=7; sq:=10; end;
    3:begin fg:=15; bg:=2; sq:=4; end;
    4:begin fg:=11; bg:=8; sq:=12; end;
    5:begin fg:=14; bg:=12; sq:=11; end;
    6:begin fg:=15; bg:=6; sq:=10; end;
    7:begin fg:=14; bg:=3; sq:=4; end;
    8:begin fg:=15; bg:=13; sq:=10; end;
   end;
  Init(1);
 clear;
 men:=0;
end;

PROCEDURE DEL_NAME;  {  DELETE NAME  }
 begin
  if sys=1 then begin strg:='      !!!';
   str1:='     '; end
    else begin strg:='  all data will deleted !!!';
     str1:='   press Space to accept'; end;
      beep(300);
   wind(25,8,55,13,2,'');
    clrscr;
     writeln(strg);
      writeln(str1);
       c:=readkey;
        if ord(c)=32 then begin
         if sys=1 then strg:='   ' else
          strg:='input student name to delete';
           writeln(strg);
            str1:=RemSpc(readstr('',30),2); writeln;
             K:=0;
             for i:=1 to ll do
             if str1=RA[i].nam then k:=i;
             if k>0 then begin
             RA[K]:=RA[ll];
            inc(ll,-1);
            file_io(1,1);
             sys:=0;
              while (sys=0) and (ord(c)<>27) do
               syst;
            end
           else begin
          if sys=1 then strg:=str1+'  '
         else strg:=str1+' not found';
        beep(200);
       writeln(strg);
      c:=readkey; end;
    end;
  clear;
 col:=0;
end;

PROCEDURE KEYS;           {  KEYS  }
var
 x,y:array [1..47] of integer;
begin
 if XGA=$A000 then
 begin
  i:=Mssg('Can not work in monochrom screen',' Warning ',11);
  exit;
 end;
 CapsOff;
 m:=0;
 mcrt.color(fg,bg);
  wind(5,4,75,22,2,'');
   textcolor(fg); textbackground(bg);
    clrscr;
     if sys=1 then begin str1:='      ';
      str2:='    '; end
       else begin str1:='Tray to press highlighted character without looking';
        str2:='to keypoard. be sure that Caps is off'; end;
         gotoxy(35-length(str1) div 2,1); writeln(str1);
         gotoxy(35-length(str2) div 2,2); writeln(str2);
       if sys=1 then str1:='\=-0987654321 '
      else str1:='`1234567890-=\qwertyuiop[]asdfghjkl;'+chr(39)+'zxcvbnm,./';
     if sys=1 then str2:='|+_()*&^%$#@!><        ":/    \.,      '
      else str2:='~!@#$%^&*()_+|QWERTYUIOP{}ASDFGHJKL:"ZXCVBNM<>?';
       gotoxy(10,6);
        for k:=0 to 3 do
         for i:=1+round(k/1.32) to 14-round(k/1.8) do
          begin
           if (sys=1) and (k=0) then m:=1 else m:=0;
             gotoxy(10+i*3+m*3+k mod 2,4+k*3);write('Ŀ');
             gotoxy(10+i*3+m*3+k mod 2,5+k*3);write(' ');
             gotoxy(10+i*3+m*3+k mod 2,6+k*3);write(' ');
         end;
       gotoxy(10,6);
     j:=0;
     for k:=0 to 3 do
      for i:=1+round(k/1.32) to 14-round(k/1.8) do
       begin
        inc(j);
         if (sys=1) and (k=0) then m:=1 else m:=0;
          x[j]:=11+i*3+m*3+k mod 2;
           y[j]:=6+k*3;
           gotoxy(x[j],y[j]);write(str1[j]);
           gotoxy(x[j],y[j]-1);write(str2[j]);
        end;
       c:=readkey; if ord(c)=27 then begin clear; exit; end;
       gettime(h0,n0,s0,ss);
        for n:=1 to 25 do
         begin
          k:=random(2);
           if k=0 then strg:=str1 else strg:=str2;
            repeat
             j:=random(47)+1;
            until strg[j]<>' ';
             textcolor(sq);
               gotoxy(x[j],y[j]-k);write(strg[j]);
                beep(50);
                 repeat
                  c:=readkey;
                  if ord(c)=27 then begin clear; exit; end;
                 until c=strg[j];
                textcolor(fg);
               gotoxy(x[j],y[j]-k);write(strg[j]);
             end;
           gettime(h1,n1,s1,ss);
         m:=wpm(h0,n0,s0,h1,n1,s1,50);
        clrscr;
       str(m,str1);
      if sys=1 then strg:=' '+str1+' /'
     else strg:='your speed is '+str1+' WPM';
    gotoxy(35-length(strg) div 2,8);
   write(strg);
  c:=readkey;
 clear;
end;

function Decode(st: string): string;
var
  i: byte;
begin
  for i:=1 to Length(st) do
    St[i]:= Char(Ord(St[i])-1);
  Decode:= St;
end;

PROCEDURE READ_DATA;   {  READ DATA  }
var s:string;
begin
 chdir(copy(dir,1,length(dir)-1));
 i:=0;
  s:='typ_'+dfn[sys,1]+'.dat';
   if Fsearch(s,'')='' then
    begin
        Error('Data file not found',0);
        color(7,0);
        window(1,1,80,25);
        cls;
        writeln(' Data file not found. Program can not be run');
        halt;
    end;
   assign(DF,dir+s);
    {$i-}
    reset(DF);
     Err:=IOResult;
     readln(DF,str1);
     if str1<>#27 then
      begin
        Error('Data file was corrupt',0);
        color(7,0);
        window(1,1,80,25);
        cls;
        writeln(' Data file was corrupt. Program can not be run');
        halt;
      end;
    repeat
      Err:=IOResult;
      if Err<>0 then begin Error('',Err);
        color(7,0);
        window(1,1,80,25);
        cls;
        writeln('Error in Data file. Program was halted');
        halt;
      end;
      inc(i);
      readln(DF,dat[i]);
      dat[i]:= Decode(dat[i]);
    until (eof(DF)) or (i=64);
 {$i+}
end;

PROCEDURE BOX(X,Y:INTEGER;S:STRING); {  BOX  }
begin
 CapsOff;
 j:=0; str3:='';
  textcolor(fg);
  gotoxy(x,y);
   if s[length(s)]<>' ' then s:=s+' ';
   write(s);
    gotoxy(x-1,y+1);write(' ');
    repeat
     until keypressed;
     gettime(h0,n0,s0,ss);
     repeat
      gotoxy(x+j,y+1);
       c:=readkey;
       if c=#0 then begin c:=readkey; c:=#9; end;
       if ord(c)=13 then c:=chr(32);
        if ord(c)>30 then begin inc(j); str3:=str3+c; end;
         if (ord(c)=8) and (str3<>'') then
         str3:=copy(str3,1,length(str3)-1);
          textcolor(fg);
          if ord(c)=27 then begin clear; exit; end;
           if (c<>s[j]) and (ord(c)<>8) then begin
            textcolor(sq); beep(1);
            if c=' ' then write(''); end;
            if ord(c)>32 then write(c);
            if (ord(c)=8) and (j>0) then begin
           inc(j,-1); gotoxy(x+j,y+1); write(' ');
          gotoxy(x+j-1,y+1); end;
         until j=length(s);
        gettime(h1,n1,s1,ss);
       spe:=wpm(h0,n0,s0,h1,n1,s1,length(s));
      f:=0;
     for j:=1 to length(s) do
    if s[j]<>str3[j] then inc(f);
   ac:=round(100-f/length(s)*100+0.1);
end;

PROCEDURE PRACTIC_TIME;       {  PRACTIC TIME  }
begin
 if (hh1=0) and (hh0>0) then hh1:=24;
  tm:=round((hh1*60+nn1+ss1/60)-(hh0*60+nn0+ss0/60));
 inc(ptime,tm);
end;

PROCEDURE SP_AC(y,a,s:integer); {  SPEED & ACCURACY  }
begin
  color(fg,bg);
 wind(25,y,55,y+4,2,'');
   clrscr;
   str(s,str3);
    str(a,str4);
     if sys=1 then begin str1:=' '+str3+' /';
     str2:=' '+str4; end
     else begin str1:='speed '+str3+' WPM';
     str2:='Accuracy '+str4; end;
   writeln(spc(8),str1);
  writeln(spc(8),str2);
end;

PROCEDURE CHOOS(x:integer);        {  CHOOS  }
begin
 strg:='';
   for m:=1 to x do begin
     g:=0; i:=0;
       k:=random(les)+1;
        if dat[k,length(dat[k])]<>' ' then dat[k]:=dat[k]+' ';
         f:=random(5);
          repeat
           inc(g);
            if dat[k,g]=' ' then inc(i);
           until i=f;
            i:=0;
             repeat
              inc(i);
              if g=1 then dec(g);
             strg:=strg+dat[k,g+i];
            until (g+i=length(dat[k])) or (dat[k,g+i]=' ');
           if (g+i=length(dat[k])) and (m<5) then strg:=strg+' ';
          end;
     while pos('  ',strg)>0 do
     delete(strg,pos('  ',strg),1);
     if c=#27 then begin clear; exit; end;
 if strg[length(strg)]<>' ' then strg:=strg+' ';
end;

PROCEDURE LESSON;          {  LESSON  }
begin
 gettime(hh0,nn0,ss0,ss);
 strg:=''; sum:=0; acSum:=0;
  inc(les);
   strg:=dat[les];
   if sys=1 then str2:=''
    else str2:='letter';
     if les>length(let[Sys]) then begin dec(les); exit; end;
      color(fg,bg);
      wind(30,16,50,19,2,'');
      clrscr;
       midle(1,str2);
       if les=1 then
        begin
         if sys=1 then begin midle(1,'  ');
         midle(2,'         ') end else
            begin midle(1,'letters');
            midle(2,'A S D F J K L ;'); end;
            end else
                midle(2,'( '+let[Sys,les]+' )');
        color(fg,bg);
         wind(20,8,60,13,2,'');
         clrscr;
         box(20-length(strg) div 2,2,strg);
         if c=#27 then begin inc(les,-1); clear; exit; end;
          for n:=1 to 5 do begin
           sp_ac(16,ac,spe);
           color(fg,bg);
           wind(20,8,60,13,2,'');
           clrscr;
           choos(5);
           box(20-length(strg) div 2,2,strg);
           sum:=sum+spe;
           acSum:=acSum+ac;
          if c=#27 then begin clear; inc(les,-1); exit; end;
         if sped=0 then sped:=spe else
        sped:=round((spe+sped+sped+sped+sped)/5);
       acur:=round((ac+acur+acur+acur+acur)/5);
      end; load;
   gettime(hh1,nn1,ss1,ss);
  practic_time;
 if les=length(let[Sys]) then theend;
end;

PROCEDURE TEST;           {  TEST  }
var
 str:array [1..5] of string[70];
begin
 gettime(hh0,nn0,ss0,ss);
 sum:=0; acsum:=0;
 color(fg,bg);
 wind(7,5,73,22,2,'');
  clrscr;
  for n:=1 to 5 do begin
   choos(9);
    str[n]:=strg;
     gotoxy(3,n*3-1);
      write(strg);
       end;
        for n:=1 to 5 do begin
         box(3,n*3-1,str[n]);
          sum:=sum+spe;
          acSum:=acSum+ac;
          if c=#27 then begin clear; exit; end;
          end;
         load;
         spe:=round(sum/5);
        ac:=round(acSum/5);
       if sped=0 then sped:=spe;
       sp_ac(8,ac,spe);
      sped:=round((spe+sped+sped+sped+sped)/5);
      acur:=round(( ac+acur+acur+acur+acur)/5);
    c:=readkey;
   clear;
  gettime(hh1,nn1,ss1,ss);
 practic_time;
end;

PROCEDURE REPORT(o:integer);  {  REPORT  }
var
 st:array [1..9] of string[50];
 s1,s2,s3,s4:string[30];
begin
 for i:=1 to 9 do st[i]:='';
 str(sped,str1);
 str(acur,str2);
 s1:=''; s2:='';
 if sys=1 then
  begin
   if RA[stu].tim>180 then begin
    str4:=' '; tm:=round(RA[stu].tim/60);
    end
    else begin
      str4:=' '; tm:=ptime;
      end;
     str(tm,str3);
   st[1]:='          : '+RA[stu].nam;
   st[2]:='        : '+RA[stu].dat;
   st[3]:='         : '+str1+' /';
   st[4]:='          : '+str2+' %';
   st[5]:='   : '+str3+str4;
   if les>0 then begin
   st[6]:='  : '+RA[stu].ldat;
   st[7]:='    : '+Let[1,les];
   st[8]:='    : '+motaz.strg(les+7);
   end;
   st[9]:=' : ';
   case sped of
   7..15:s1:='';
   16..30:s1:='';
   31..49:s1:=' ';
   50..120:s1:='';
   end;
   case acur of
   95..100:s2:='';
   80..94:s2:='';
   60..79:s2:='';
   0..59:s2:=' ';
   end;
   strg:='*******  *******';
   s3:=' ';
   s4:='  ';
  end
 else
  begin
   if RA[stu].tim>180 then begin
    str4:=' Hours'; tm:=round(RA[stu].tim/60);
    end
    else begin
      str4:=' Minutes'; tm:=ptime;
      end;
     str(tm,str3);
   st[1]:='Name           : '+RA[stu].nam;
   st[2]:='Begin          : '+RA[stu].dat;
   st[3]:='Speed          : '+str1+' WPM';
   st[4]:='Accuracy       : '+str2+' %';
   st[5]:='Practice time  : '+str3+str4;
   if les>0 then begin
   st[6]:='Last practice  : '+RA[stu].ldat;
   st[7]:='Current letter : '+Let[2,les];
   st[8]:='Num. of practice letters : '+motaz.strg(les+7);
   end;
   st[9]:='Remarks : ';
   case sped of
   7..15:s1:='acceptable';
   16..30:s1:='good';
   31..49:s1:='very good';
   50..120:s1:='excellent';
   end;
   case acur of
   95..100:s2:='very good';
   80..94:s2:='good';
   60..79:s2:='bad';
   0..59:s2:='very bad';
   end;
   strg:='******************  REPORT  *****************';
  s3:='Speed    ';
  s4:='Accuracy ';
  end;
    if o=1 then begin
     color(fg,bg);
     wind(10,4,70,21,2,'');
     clrscr;
      gotoxy(30-length(strg) div 2,2);
       writeln(strg);
        writeln;
        for i:=1 to 9 do
       writeln('       ',st[i]);
       if RA[stu].tim>0 then begin
       writeln(spc(15),s3+' : ',s1);
       writeln(spc(15),s4+' : ',s2);
      end;
      c:='1';
      c:=readkey;
     clear;
    end
     else begin
      color(fg,bg);
       {$i-}
       write(lst,#7);
       {$i+}
       Err:=IOResult;
       if Err<>0 then begin Error('Printer not ready',Err); exit; end
        else begin
       {$i-}
       for i:=1 to 5 do writeln(lst,' ');
       writeln(lst,'                   ',strg);
       writeln(lst,'');
      for i:=1 to 9 do begin
        Err:=IOResult;
       if Err>0 then begin Error('Printer not ready',Err); {$i+} exit; end;
       writeln(lst,'                                    ',st[i]);
        writeln(lst);
        end;
        if RA[stu].tim>0 then begin
       writeln(lst,spc(54),s3+s1);
       writeln(lst,spc(54),s4+s2);
      end;
       for i:=1 to 3 do writeln(lst,'');
       if sys=1 then writeln(lst,spc(54),'   ... ')
       else writeln(lst,spc(54),'with best whishes, Motaz');
      end;
   end;
 {$i+}
end;

PROCEDURE TEXT;     {  TEXT FILE  }
var fn:array [1..20] of string[75];
    f:searchrec;
begin
  i:=0; strg:=''; sum:=0; acSum:=0;
   FindFirst(dir+'*.tx'+dfn[sys,1], Archive, f);
   if doserror=0 then begin
   inc(i); fn[i]:=f.name;
   repeat
   inc(i);
    FindNext(f);
     fn[i]:=f.name;
      until (doserror<>0) or (i=20); end;
       if doserror>0 then inc(i,-1);
       for j:=1 to i do
        strg:=strg+fn[j]+'+';
         if length(strg)<3 then begin
         if sys=1 then strg:='         TXA'
          else strg:='    File *.TXE not found';
          color(fg,bg);
          wind(25,11,55,13,2,'');
           clrscr;
           writeln; write(strg);
           c:=readkey;
           clear;
           exit;
          end;
         repeat
          menu(35,12-i div 2,strg,'');
           until (men>0) or (c=#27);
           if c=#27 then begin clear; exit; end;
            strg:=fn[men];
            assign(fl,dir+strg);
             {$i-}
             reset(fl);
              l:=0;
               repeat
             Err:=IOResult;
             if Err<>0 then begin Error('',Err); exit end;
               inc(l);
               readln(fl,fn[l]);
               until (eof(fl)) or (l=20) or (length(fn[l])<3);
               close(fl);
               if length(fn[l])<3 then inc(l,-1);
               color(fg,bg);
              wind(2,2,78,24,2,' '+strg+' ');
             clrscr;
             if l<=10 then g:=l else g:=10;
             gettime(hh0,nn0,ss0,ss);
            for i:=1 to g do
           begin
          gotoxy(2,i*2-1);
         write(fn[i]);
        end;
       for n:=1 to g do
       begin
       box(2,n*2-1,fn[n]);
       sum:=sum+spe;
       acSum:=acSum+ac;
       if c=#27 then begin clear; exit; end;
       end;
      if l>10 then begin
      clrscr;
        textcolor(fg);
        for i:=11 to l do
           begin
          gotoxy(2,(i-10)*2);
         write(fn[i]);
        end;
       for n:=11 to l do
       begin
       box(2,(n-10)*2,fn[n]);
        sum:=sum+spe;
         acSum:=acSum+ac;
        if c=#27 then begin clear; exit; end;
       end;
       end;
       load;
       spe:=round(sum/l);
       ac:=round(acSum/l);
       sp_ac(8,ac,spe);
      sped:=round((spe+sped+sped+sped+sped)/5);
     acur:=round((ac+acur+acur+acur+acur)/5);
    gettime(hh1,nn1,ss1,ss);
   practic_time;
  c:=readkey;
end;

PROCEDURE HELP;        {  HELP  }
var
 st:array [1..175] of string[64];
begin
 strg:='typ_'+DFN[sys,1]+'.hlp';
  l:=0; j:=0;
   assign(fl,dir+strg);
    {$i-}
    reset(fl);
     readln(fl,str1);
     if str1<>#27 then
      begin
        Error(' Help file was corrupt ',0);
        {$i+}
        exit;
      end;
     repeat
     Err:=IOResult;
     if Err<>0 then begin Error('',Err);
     i:=Mssg(' Help file not found - '+ucase(strg),' Error ',11);
     {$i+}
     exit; end;
     inc(l);
      readln(fl,st[l]);
      st[l]:=Decode(st[l]);
      until eof(fl);
       close(fl);
       {$i+}
        color(fg,bg);
        wind(5,6,75,20,2,'');
         cls;
         repeat
          for i:=1 to 12 do begin
            if pos('<',st[i+j])>0 then textcolor(sq)
              else textcolor(fg);
            if j+i<=l then begin gotoxy(4,i);
             write(st[i+j],spc(64-length(st[i+j])));
             gotoxy(1,12); end;
            end;
           c:=readkey;
          case ord(c) of
           13,32,81:inc(j,12);
           73:inc(j,-12);
           72:inc(j,-1);
           80:inc(j);
           71:j:=0;
           79:j:=l;
           27:begin clear; exit; end;
          end;
     if j+i>l then j:=l-i else
    if j<0 then j:=0;
  until c=#27;
end;

Procedure Change_Sound;    {   Change Sound  }
Begin
 Soun:=Not Soun;
 Init(1);
end;


BEGIN                {   Start   }
 CheckBreak:=false;
 Mode;
 GetDir(0,Cdir);
 dir:=paramstr(0);
 if pos('TYP',ucase(dir))=0 then dir:='' else
repeat
 delete(dir,length(dir),1);
until dir[length(dir)]='\';
na:='By : Motaz Abdel Azim';
if (length(na)<>21) or (na[1]<>'B') or (na[7]<>'o') or (na[19]<>'z') then
 begin writeln('Program was corrupt'); exit; end;
if pos(paramstr(1),'aAeE')=0 then
begin writeln;
 writeln('  Typing Tutorial  Ver 1.2');
 writeln('   ',na);
 writeln;
 writeln(spc(5),'Usage :');
 writeln(spc(15),'TYP < A | E >');
 if paramstr(1)<>'' then exit;
 end;
ex:=false; Soun:=True;
rg.ax:=3; mouy:=0; moux:=0; rg.cx:=0; rg.dx:=0; col:=0;
bg:=9; fg:=14; sq:=12; stu:=0; sys:=0;
randomize;
Init(0);
textbackground(bg);
clrscr;
clear;
getdate(yy,mm,dd,dw);
for i:=1 to 16 do
 begin
 color(fg,bg);
  wind(40-i,4,40+i,6,2,'');
   clrscr;
    delay(5);
     end;
     beep(100);
    write('         ');
   about;
  if ord(c)=27 then ext;
while (sys=0) and (ord(c)<>27) do
syst;
clear;
read_data;
les:=RA[stu].last;
sped:=RA[stu].speed;
acur:=RA[stu].acur;
ptime:=RA[stu].tim;
delay(200);

repeat             {  MAIN LOOP  }
 menu_bar;
 if col=0 then clear;
 if (col=1) and (men=1) then lesson;
 if (col=1) and (men=2) then test;
 if (col=1) and (men=3) then keys;
 if (col=1) and (men=4) then text;
 if (col=2) and (men=1) then begin rename; if strg<>'' then file_io(1,1); end;
 if (col=2) and (men=2) then colors;
 if (col=2) and (men=3) then Change_Sound;
 if  col=3 then report(men);
 if (col=4) and (men=1) then help;
 if (col=4) and (men=2) then about;
 if (col=5) and (men=1) then del_name;
 if (col=5) and (men=2) then begin ext; exit; end;
until ex;
end.